//Pico_Logik 8 Eingänge, 1 µs
#include "pico/stdlib.h"
#include "div16.h"

void setup() {
  Serial.begin(115200); 
  pio_gpio_init(pio0, 2);         
  pio_gpio_init(pio0, 3);         
  pio_gpio_init(pio0, 4);         
  pio_gpio_init(pio0, 5);         
  uint offset = pio_add_program(pio0, &div16_program);         
  pio_sm_set_consecutive_pindirs(pio0, 0, 2, 4, true);          
  pio_sm_config c = div16_program_get_default_config(offset); 
  sm_config_set_set_pins(&c, 2, 4);                  
  sm_config_set_clkdiv(&c, 1250);                       
  pio_sm_init(pio0, 0, offset, &c);       
  pio_sm_set_enabled(pio0, 0, true);
  while(true);
}

void loop() {
}

void setup1() {
  uint32_t ports[1000]; 
  int dt=1;
  while (true) {  
    if (Serial.available()){
      int dt2 = Serial.parseInt();
      if( dt2>0) dt=dt2;
    }
    uint32_t t = time_us_32();
    for (int n = 0; n < 500; n++){
      ports[n]=gpio_get_all();
      t+=dt; while (t>time_us_32());  
    }
    for (int n = 0; n < 500; n++){
      Serial.print (64*(ports[n]&1)) ;
      Serial.print (" ");
      Serial.print (100+32*(ports[n]&2)) ;
      Serial.print (" ");
      Serial.print (200+16*(ports[n]&4)) ;
      Serial.print (" ");
      Serial.print (300+8*(ports[n]&8)) ;
      Serial.print (" ");
      Serial.print (400+4*(ports[n]&16)) ;
      Serial.print (" ");
      Serial.print (500+2*(ports[n]&32)) ;
      Serial.print (" ");
      Serial.print (600+1*(ports[n]&64)) ;
      Serial.print (" ");
      Serial.println (700+(ports[n]&128)/2) ;
    }
    sleep_ms(1000);
  }
}  

void loop1() {
}
